## samba4 4.0.0~alpha13+git+bzr12984.dfsg1

=== pidl/wscript ===
#!/usr/bin/env python

import os

def set_options(opt):
    opt.tool_options('perl')

def configure(conf):
    conf.check_tool('perl')
    # we need a recent version of MakeMaker to get the right man page names
    if conf.CHECK_PERL_MANPAGE():
        conf.env.PERLMAN1EXT = conf.CHECK_PERL_MANPAGE(section='1')
        conf.env.PERLMAN3EXT = conf.CHECK_PERL_MANPAGE(section='3')
        conf.DEFINE('HAVE_PERL_MAKEMAKER', 1)

    # yapp is used for building the parser
    conf.find_program('yapp', var='YAPP')
    conf.find_program('pod2man', var='POD2MAN')

def build(bld):
    bld.INSTALL_FILES('${BINDIR}', 'pidl', chmod=0755)

    bld.RECURSE('lib')

    if not bld.CONFIG_SET('HAVE_PERL_MAKEMAKER'):
        return

    pidl_src = ['pidl']
    pidl_src.extend(bld.path.ant_glob('lib/**/*.pm').split())

    pidl_manpages = {
        'pidl': 'man1/pidl.${PERLMAN1EXT}',
        'lib/Parse/Pidl/NDR.pm': 'man3/Parse::Pidl::NDR.${PERLMAN3EXT}',
        'lib/Parse/Pidl/Wireshark/Conformance.pm': 'man3/Parse::Pidl::Wireshark::Conformance.${PERLMAN3EXT}',
        'lib/Parse/Pidl/Dump.pm': 'man3/Parse::Pidl::Dump.${PERLMAN3EXT}',
        'lib/Parse/Pidl/Util.pm': 'man3/Parse::Pidl::Util.${PERLMAN3EXT}',
        'lib/Parse/Pidl/Wireshark/NDR.pm': 'man3/Parse::Pidl::Wireshark::NDR.${PERLMAN3EXT}'
    }

    for k, v in pidl_manpages.iteritems():
        pidl_manpages[k] = bld.EXPAND_VARIABLES(v)

    # use perl to build the manpages
    bld.env.pidl_srcdir = os.path.join(bld.srcnode.abspath(), 'pidl')

    blib_bld = os.path.join(bld.srcnode.abspath(bld.env), 'pidl/blib')

    link_command = 'rm -rf blib && ln -fs blib %s' % blib_bld
    
    bld.SET_BUILD_GROUP('final')
    if 'POD2MAN' in bld.env and bld.env['POD2MAN'] != '':
        for src, manpage in pidl_manpages.iteritems():
            bld(rule='${PERL} ${POD2MAN} -c "Samba Documentation" ${SRC} ${TGT}',
                shell=True,
                source=src,
                install_path=os.path.dirname(bld.EXPAND_VARIABLES('${MANDIR}/'+manpage)),
                target=os.path.basename(manpage))

    # we want to prefer the git version of the parsers if we can. Only if the
    # source has changed do we want to re-run yapp
    need_yapp_build = ('YAPP' in bld.env and (
        bld.IS_NEWER('idl.yp', 'lib/Parse/Pidl/IDL.pm') or
        bld.IS_NEWER('expr.yp', 'lib/Parse/Pidl/Expr.pm')))

    if need_yapp_build:
        t = bld.SAMBA_GENERATOR('pidl_parser',
                                source='idl.yp expr.yp',
                                target='lib/Parse/Pidl/IDL.pm lib/Parse/Pidl/Expr.pm Makefile.PL',
                                rule='cd ${pidl_srcdir} && ${LINK_COMMAND} && ${PERL} Makefile.PL && make lib/Parse/Pidl/IDL.pm lib/Parse/Pidl/Expr.pm && rm -f Makefile Makefile.old && rm -f blib')
        t.env.LINK_COMMAND = link_command

=== source4/wscript ===
#! /usr/bin/env python

srcdir = '..'
blddir = 'bin'

APPNAME='samba'
VERSION=None

import sys, os
sys.path.insert(0, srcdir+"/buildtools/wafsamba")
import wafsamba, Options, samba_dist, Scripting


def load_version(have_git=False):
    '''load samba versions either from ./VERSION or git
    return a version object for detailed breakdown'''
    import samba_utils, Utils
    if not have_git:
        env = samba_utils.LOAD_ENVIRONMENT()
        have_git = 'GIT' in env
    version = wafsamba.samba_version_file("./VERSION", have_git=have_git)
    Utils.g_module.VERSION = version.STRING
    return version


samba_dist.DIST_DIRS('.')

#This is a list of files that we don't want in the package, for
#whatever reason.  Directories should be listed with a trailing / to
#avoid over-exclusion.

#This list includes files that would confuse the recipient of a
#samba-4.0.0 branded tarball (until the merge is complete) and the
#core elements of the autotools build system (which is known to
#produce buggy binaries).
samba_dist.DIST_BLACKLIST('README Manifest Read-Manifest-Now Roadmap source3/ ' +
                          'packaging/ docs-xml/ examples/ swat/ WHATSNEW.txt MAINTAINERS ' +
                          'source4/autogen-autotools.sh source4/Makefile.in source4/configure.ac')
# install in /usr/local/samba by default
Options.default_prefix = '/usr/local/samba'


def set_options(opt):
    opt.BUILTIN_DEFAULT('replace')
    opt.BUNDLED_EXTENSION_DEFAULT('samba4')
    opt.RECURSE('../lib/replace')
    opt.RECURSE('dynconfig')
    opt.RECURSE('scripting/python')
    opt.RECURSE('lib/ldb')
    opt.RECURSE('selftest')
    opt.RECURSE('lib/tls')
    opt.RECURSE('../lib/nss_wrapper')
    opt.RECURSE('../lib/socket_wrapper')
    opt.RECURSE('../lib/uid_wrapper')
    opt.RECURSE('../pidl')

    gr = opt.option_group('developer options')
    gr.add_option('--enable-build-farm',
                   help='enable special build farm options',
                   action='store_true', dest='BUILD_FARM')


def configure(conf):
    version = load_version(have_git=True)

    conf.DEFINE('PACKAGE_NAME', 'samba', quote=True)
    conf.DEFINE('PACKAGE_STRING', 'Samba ' + version.STRING, quote=True)
    conf.DEFINE('PACKAGE_TARNAME',  'samba', quote=True)
    conf.DEFINE('PACKAGE_URL', "http://www.samba.org/", quote=True)
    conf.DEFINE('PACKAGE_VERSION', version.STRING, quote=True)
    conf.DEFINE('PACKAGE_BUGREPORT', 'http://bugzilla.samba.org/', quote=True)

    conf.DEFINE('CONFIG_H_IS_FROM_SAMBA', 1)
    conf.DEFINE('_SAMBA_BUILD_', version.MAJOR, add_to_cflags=True)
    conf.DEFINE('HAVE_CONFIG_H', 1, add_to_cflags=True)

    if Options.options.developer:
        conf.ADD_CFLAGS('-DDEVELOPER -DDEBUG_PASSWORD')

    # this enables smbtorture.static for s3 in the build farm
    conf.env.BUILD_FARM = Options.options.BUILD_FARM or os.environ.get('RUN_FROM_BUILD_FARM')

    # set a lower limit on recursing in waf preprocessor
    conf.env.preprocessor_recursion_limit = 10

    conf.ADD_EXTRA_INCLUDES('#source4 #lib #source4/lib #source4/include')

    conf.RECURSE('../lib/replace')

    conf.find_program('python', var='PYTHON', mandatory=True)
    conf.find_program('perl', var='PERL', mandatory=True)
    conf.find_program('xsltproc', var='XSLTPROC')

    # enable tool to build python extensions
    conf.check_tool('python')
    conf.check_python_version((2,4,2))
    conf.check_python_headers(mandatory=True)

    conf.RECURSE('dynconfig')
    conf.RECURSE('scripting/python')
    conf.RECURSE('lib/ldb')
    conf.RECURSE('heimdal_build')
    conf.RECURSE('lib/tls')
    conf.RECURSE('ntvfs/sysdep')
    conf.RECURSE('../lib/util')
    conf.RECURSE('../lib/zlib')
    conf.RECURSE('../lib/util/charset')
    conf.RECURSE('auth')
    conf.RECURSE('../lib/nss_wrapper')
    conf.RECURSE('../nsswitch')
    conf.RECURSE('../lib/socket_wrapper')
    conf.RECURSE('../lib/uid_wrapper')
    conf.RECURSE('../lib/popt')
    conf.RECURSE('lib/smbreadline')
    conf.RECURSE('../pidl')
    conf.RECURSE('selftest')

    # we don't want PYTHONDIR in config.h, as otherwise changing
    # --prefix causes a complete rebuild
    del(conf.env.defines['PYTHONDIR'])
    conf.SAMBA_CONFIG_H('include/config.h')


def etags(ctx):
    '''build TAGS file using etags'''
    import Utils
    source_root = os.path.dirname(Utils.g_module.root_path)
    cmd = 'etags $(find %s/.. -name "*.[ch]")' % source_root
    print("Running: %s" % cmd)
    os.system(cmd)

def ctags(ctx):
    "build 'tags' file using ctags"
    import Utils
    source_root = os.path.dirname(Utils.g_module.root_path)
    cmd = 'ctags $(find %s/.. -name "*.[ch]" | grep -v "*_proto\.h")' % source_root
    print("Running: %s" % cmd)
    os.system(cmd)

# putting this here enabled build in the list
# of commands in --help
def build(bld):
    '''build all targets'''
    load_version()
    pass


def pydoctor(ctx):
    '''build python apidocs'''
    cmd='LD_LIBRARY_PATH=bin/shared PYTHONPATH=bin/python pydoctor --project-name=Samba --project-url=http://www.samba.org --make-html --docformat=restructuredtext --add-package bin/python/samba'
    print("Running: %s" % cmd)
    os.system(cmd)

def wafdocs(ctx):
    '''build wafsamba apidocs'''
    from samba_utils import recursive_dirlist
    os.system('pwd')
    list = recursive_dirlist('../buildtools/wafsamba', '.', pattern='*.py')

    cmd='LD_LIBRARY_PATH=bin/shared PYTHONPATH=bin/python pydoctor --project-name=wafsamba --project-url=http://www.samba.org --make-html --docformat=restructuredtext'
    print(list)
    for f in list:
        cmd += ' --add-module %s' % f
    print("Running: %s" % cmd)
    os.system(cmd)


def dist():
    '''makes a tarball for distribution'''
    load_version()
    samba_dist.dist()

def distcheck():
    '''test that distribution tarball builds and installs'''
    load_version()
    import Scripting
    d = Scripting.distcheck
    d(subdir='source4')

def wildcard_cmd(cmd):
    '''called on a unknown command'''
    from samba_wildcard import run_named_build_task
    run_named_build_task(cmd)

def main():
    from samba_wildcard import wildcard_main
    wildcard_main(wildcard_cmd)
Scripting.main = main

def reconfigure(ctx):
    '''reconfigure if config scripts have changed'''
    import samba_utils
    samba_utils.reconfigure(ctx)

=== lib/nss_wrapper/wscript ===
#!/usr/bin/env python

import Options

def set_options(opt):
	gr = opt.option_group('developer options')
	gr.add_option('--enable-nss-wrapper',
		      help=("Turn on nss wrapper library (default=no)"),
		      action="store_true", dest='enable_nss_wrapper', default=False)

def configure(conf):
    if (Options.options.enable_nss_wrapper or
	Options.options.developer or
	Options.options.enable_selftest):
        conf.DEFINE('NSS_WRAPPER', 1)

=== lib/tdb/wscript ===
#!/usr/bin/env python

APPNAME = 'tdb'
VERSION = '1.2.4'

blddir = 'bin'

import sys, os

# find the buildtools directory
srcdir = '.'
while not os.path.exists(srcdir+'/buildtools') and len(srcdir.split('/')) < 5:
    srcdir = '../' + srcdir
sys.path.insert(0, srcdir + '/buildtools/wafsamba')

import wafsamba, samba_dist, Options, Logs

samba_dist.DIST_DIRS('lib/tdb:. lib/replace:lib/replace buildtools:buildtools')

def set_options(opt):
    opt.BUILTIN_DEFAULT('replace')
    opt.BUNDLED_EXTENSION_DEFAULT('tdb', noextension='tdb')
    opt.RECURSE('lib/replace')
    if opt.IN_LAUNCH_DIR():
        opt.add_option('--disable-python',
                       help=("disable the pytdb module"),
                       action="store_true", dest='disable_python', default=False)


def configure(conf):
    conf.RECURSE('lib/replace')

    conf.env.standalone_tdb = conf.IN_LAUNCH_DIR()

    if not conf.env.standalone_tdb:
        if conf.CHECK_BUNDLED_SYSTEM('tdb', minversion=VERSION,
                                     implied_deps='replace'):
            conf.define('USING_SYSTEM_TDB', 1)

    conf.env.disable_python = getattr(Options.options, 'disable_python', False)

    conf.CHECK_XSLTPROC_MANPAGES()

    if not conf.env.disable_python:
        # also disable if we don't have the python libs installed
        conf.check_tool('python')
        conf.check_python_version((2,4,2))
        conf.check_python_headers(mandatory=False)
        if not conf.env.HAVE_PYTHON_H:
            Logs.warn('Disabling pytdb as python devel libs not found')
            conf.env.disable_python = True

    conf.SAMBA_CONFIG_H()

def build(bld):
    bld.RECURSE('lib/replace')

    COMMON_SRC = bld.SUBDIR('common',
                            '''check.c error.c tdb.c traverse.c
                            freelistcheck.c lock.c dump.c freelist.c
                            io.c open.c transaction.c''')

    if not bld.CONFIG_SET('USING_SYSTEM_TDB'):
        bld.SAMBA_LIBRARY('tdb',
                          COMMON_SRC,
                          deps='replace',
                          includes='include',
                          abi_file='ABI/tdb-%s.sigs' % VERSION,
                          abi_match='tdb_*',
                          hide_symbols=True,
                          vnum=VERSION, is_bundled=not bld.env.standalone_tdb)

        bld.SAMBA_BINARY('tdbtorture',
                         'tools/tdbtorture.c',
                         'tdb',
                         install=False)

        bld.SAMBA_BINARY('tdbdump',
                         'tools/tdbdump.c',
                         'tdb', manpages='manpages/tdbdump.8')

        bld.SAMBA_BINARY('tdbbackup',
                         'tools/tdbbackup.c',
                         'tdb',
                         manpages='manpages/tdbbackup.8')

        bld.SAMBA_BINARY('tdbtool',
                         'tools/tdbtool.c',
                         'tdb', manpages='manpages/tdbtool.8')

    s4_build = getattr(bld.env, '_SAMBA_BUILD_', 0) == 4

    bld.SAMBA_PYTHON('pytdb',
                     'pytdb.c',
                     deps='tdb',
                     enabled=not bld.env.disable_python,
                     realname='tdb.so')

    if bld.env.standalone_tdb:
        bld.env.PKGCONFIGDIR = '${LIBDIR}/pkgconfig'
        bld.PKG_CONFIG_FILES('tdb.pc', vnum=VERSION)
        bld.INSTALL_FILES('${INCLUDEDIR}', 'include/tdb.h', flat=True)


def test(ctx):
    '''run tdb testsuite'''
    import Utils
    cmd = os.path.join(Utils.g_module.blddir, 'tdbtorture')
    os.system(cmd)

def dist():
    '''makes a tarball for distribution'''
    samba_dist.dist()

=== lib/testtools/Makefile ===
# See README for copyright and licensing details.

PYTHON=python
SOURCES=$(shell find testtools -name "*.py")

check:
	PYTHONPATH=$(PWD) $(PYTHON) -m testtools.run testtools.tests.test_suite

TAGS: ${SOURCES}
	ctags -e -R testtools/

tags: ${SOURCES}
	ctags -R testtools/

clean:
	rm -f TAGS tags
	find testtools -name "*.pyc" -exec rm '{}' \;

release:
	# An existing MANIFEST breaks distutils sometimes. Avoid that.
	-rm MANIFEST
	./setup.py sdist upload --sign

apidocs:
	pydoctor --make-html --add-package testtools \
		--docformat=restructuredtext --project-name=testtools \
		--project-url=https://launchpad.net/testtools


.PHONY: check clean release apidocs

=== lib/tevent/wscript ===
#!/usr/bin/env python

APPNAME = 'tevent'
VERSION = '0.9.9'

blddir = 'bin'

import sys, os

# find the buildtools directory
srcdir = '.'
while not os.path.exists(srcdir+'/buildtools') and len(srcdir.split('/')) < 5:
    srcdir = '../' + srcdir
sys.path.insert(0, srcdir + '/buildtools/wafsamba')

import wafsamba, samba_dist

samba_dist.DIST_DIRS('lib/tevent:. lib/replace:lib/replace lib/talloc:lib/talloc buildtools:buildtools')

def set_options(opt):
    opt.BUILTIN_DEFAULT('replace')
    opt.BUNDLED_EXTENSION_DEFAULT('tevent', noextension='tevent')
    opt.RECURSE('lib/replace')
    opt.RECURSE('lib/talloc')

def configure(conf):
    conf.RECURSE('lib/replace')
    conf.RECURSE('lib/talloc')

    conf.env.standalone_tevent = conf.IN_LAUNCH_DIR()

    if not conf.env.standalone_tevent:
        if conf.CHECK_BUNDLED_SYSTEM('tevent', minversion=VERSION,
                                     onlyif='talloc', implied_deps='replace talloc'):
            conf.define('USING_SYSTEM_TEVENT', 1)

    if conf.CHECK_FUNCS('epoll_create', headers='sys/epoll.h'):
        conf.DEFINE('HAVE_EPOLL', 1)

    conf.SAMBA_CONFIG_H()

def build(bld):
    bld.RECURSE('lib/replace')
    bld.RECURSE('lib/talloc')

    SRC = '''tevent.c tevent_debug.c tevent_fd.c tevent_immediate.c
             tevent_queue.c tevent_req.c tevent_select.c
             tevent_signal.c tevent_standard.c tevent_timed.c tevent_util.c tevent_wakeup.c'''

    if bld.CONFIG_SET('HAVE_EPOLL'):
        SRC += ' tevent_epoll.c'

    if not bld.CONFIG_SET('USING_SYSTEM_TEVENT'):
        bld.SAMBA_LIBRARY('tevent',
                          SRC,
                          deps='replace talloc',
                          enabled= not bld.CONFIG_SET('USING_SYSTEM_TEVENT'),
                          abi_file='ABI/tevent-%s.sigs' % VERSION,
                          abi_match='tevent_* _tevent_*',
                          vnum=VERSION, 
						  is_bundled=not bld.env.standalone_tevent)

    if bld.env.standalone_tevent:
        bld.env.PKGCONFIGDIR = '${LIBDIR}/pkgconfig'
        bld.PKG_CONFIG_FILES('tevent.pc', vnum=VERSION)
        bld.INSTALL_FILES('${INCLUDEDIR}', 'tevent.h')

def test(ctx):
    '''test tevent'''
    print("The tevent testsuite is part of smbtorture in samba4")


def dist():
    '''makes a tarball for distribution'''
    samba_dist.dist()

=== lib/zlib/wscript ===
#!/usr/bin/env python

def configure(conf):
    conf.CHECK_HEADERS('zlib.h')
    conf.CHECK_FUNCS_IN('zlibVersion', 'z')

    conf.CHECK_CODE('''
                    #if (ZLIB_VERNUM >= 0x1230)
                    #else
                    #error "ZLIB_VERNUM < 0x1230"
                    #endif
                    ''',
                    headers='zlib.h',
                    local_include=False,
                    msg='Checking for ZLIB_VERNUM >= 0x1230',
                    define='HAVE_ZLIB')

def build(bld):
    if bld.CONFIG_SET('HAVE_ZLIB'):
        bld.TARGET_ALIAS('z', 'ZLIB')
    else:
        bld.SAMBA_LIBRARY('ZLIB',
                          deps='replace',
                          source='''adler32.c compress.c crc32.c gzio.c
                                    uncompr.c deflate.c trees.c zutil.c
                                    inflate.c infback.c inftrees.c inffast.c''')

=== source4/dynconfig/wscript ===
#!/usr/bin/env python

import string, Utils, Options, sys
from samba_utils import EXPAND_VARIABLES

# list of directory options to offer in configure
dir_options = {
    'with-piddir'                         : [ '${PREFIX}/var/run', 'where to put pid files' ],
    'with-privatedir'                     : [ '${PREFIX}/private', 'Where to put sam.ldb and other private files' ],
    'with-winbindd-socket-dir'            : [ '${PREFIX}/var/lib/winbindd', 'winbind socket directory' ],
    'with-winbindd-privileged-socket-dir' : [ '${PREFIX}/var/lib/winbindd_privileged', 'winbind privileged socket directory'],
    'with-ntp-signd-socket-dir'           : [ '${PREFIX}/var/run/ntp_signd', 'NTP signed directory'],
    'with-lockdir'                        : [ '${PREFIX}/var/locks', 'where to put lock files' ]
    }

# list of cflags to use for dynconfig.c
dyn_cflags = {
    'BINDIR'                         : '${BINDIR}',
    'SBINDIR'                        : '${SBINDIR}',
    'CONFIGDIR'                      : '${SYSCONFDIR}',
    'CONFIGFILE'                     : '${SYSCONFDIR}/smb.conf',
    'LMHOSTSFILE'                    : '${SYSCONFDIR}/lmhosts',
    'PRIVATE_DIR'                    : '${PRIVATEDIR}',
    'LOGFILEBASE'                    : '${LOCALSTATEDIR}',
    'LOCKDIR'                        : '${LOCALSTATEDIR}/locks',
    'PIDDIR'                         : '${LOCALSTATEDIR}/run',
    'DATADIR'                        : '${DATADIR}',
    'SETUPDIR'                       : '${DATADIR}/setup',
    'WINBINDD_SOCKET_DIR'            : '${WINBINDD_SOCKET_DIR}',
    'WINBINDD_PRIVILEGED_SOCKET_DIR' : '${WINBINDD_PRIVILEGED_SOCKET_DIR}',
    'NTP_SIGND_SOCKET_DIR'           : '${NTP_SIGND_SOCKET_DIR}',
    'NCALRPCDIR'                     : '${LOCALSTATEDIR}/ncalrpc',
    'PYTHONDIR'                      : '${PYTHONDIR}',
    'MODULESDIR'                     : '${PREFIX}/modules',
    'INCLUDEDIR'                     : '${PREFIX}/include',
    'PKGCONFIGDIR'                   : '${LIBDIR}/pkgconfig',
    'SWATDIR'                        : '${DATADIR}/swat',
    'CODEPAGEDIR'                    : '${LIBDIR}/samba',
    'LIBDIR'                         : '${LIBDIR}',
    'STATEDIR'                       : '${LOCALSTATEDIR}',
    'CACHEDIR'                       : '${LOCKDIR}',
    'SMB_PASSWD_FILE'                : '${PRIVATEDIR}/smbpasswd',
    }

# changes for when FHS is enabled
dyn_cflags_fhs = {
    'BINDIR'                         : '${BINDIR}',
    'SBINDIR'                        : '${SBINDIR}',
    'CONFIGDIR'                      : '${SYSCONFDIR}/samba',
    'CONFIGFILE'                     : '${SYSCONFDIR}/samba/smb.conf',
    'LMHOSTSFILE'                    : '${SYSCONFDIR}/samba/lmhosts',
    'PRIVATE_DIR'                    : '${LOCALSTATEDIR}/lib/samba/private',
    'LOGFILEBASE'                    : '${LOCALSTATEDIR}/log/samba',
    'LOCKDIR'                        : '${LOCALSTATEDIR}/lib/samba',
    'PIDDIR'                         : '${LOCALSTATEDIR}/run/samba',
    'DATADIR'                        : '${DATADIR}/samba',
    'SETUPDIR'                       : '${DATADIR}/samba/setup',
    'WINBINDD_SOCKET_DIR'            : '${LOCALSTATEDIR}/run/samba/winbindd',
    'WINBINDD_PRIVILEGED_SOCKET_DIR' : '${LOCALSTATEDIR}/run/samba/winbindd_privileged',
    'NTP_SIGND_SOCKET_DIR'           : '${LOCALSTATEDIR}/run/samba/ntp_signd',
    'NCALRPCDIR'                     : '${LOCALSTATEDIR}/ncalrpc',
    'PYTHONDIR'                      : '${PYTHONDIR}',
    'MODULESDIR'                     : '${LIBDIR}/samba',
    'INCLUDEDIR'                     : '${INCLUDEDIR}/samba-4.0',
    'PKGCONFIGDIR'                   : '${LIBDIR}/pkgconfig',
    'SWATDIR'                        : '${DATADIR}/swat',
    }

def get_varname(v):
    '''work out a variable name from a configure option name'''
    if v.startswith('with-'):
        v = v[5:]
    v = v.upper()
    v = v.replace('-', '_')
    return v


def set_options(opt):
    # get all the basic GNU options from the gnu_dirs tool
    opt.add_option('--enable-fhs',
                   help=("Use FHS-compliant paths (default no)"),
                   action="store_true", dest='ENABLE_FHS', default=False)
    for option in dir_options.keys():
        default = dir_options[option][0]
        help    = dir_options[option][1]
        varname = get_varname(option)
        opt.add_option('--%s' % option,
                       help=(help + ' [%s]' % default),
                       action="store", dest=varname, default=default)

def configure(conf):
    # get all the basic GNU options from the gnu_dirs tool
    for option in dir_options.keys():
        varname = get_varname(option)
        value = getattr(Options.options, varname, None)
        conf.ASSERT(value is not None, "Missing configure option %s" % varname)
        conf.ASSERT(varname not in conf.env, "Variable %s already defined" % varname)
        conf.env[varname] = value

    for f in dyn_cflags.keys():
        v = EXPAND_VARIABLES(conf, dyn_cflags[f])
        conf.ASSERT(v != '', "Empty dynconfig value for %s" % f)
        conf.env[f] = v

    if Options.options.ENABLE_FHS:
        for f in dyn_cflags_fhs.keys():
            v = EXPAND_VARIABLES(conf, dyn_cflags_fhs[f])
            conf.ASSERT(v != '', "Empty dynconfig value for %s" % f)
            conf.env[f] = v

    if (not Options.options.ENABLE_FHS and
        (conf.env.PREFIX == '/usr' or conf.env.PREFIX == '/usr/local')):
        print("ERROR: Don't install directly under /usr or /usr/local without using the FHS option (--enable-fhs)")
        sys.exit(1)


def dynconfig_cflags(bld):
    '''work out the extra CFLAGS for dynconfig.c'''
    cflags = []
    for f in dyn_cflags.keys():
        cflags.append('-D%s="%s"' % (f, bld.env[f]))
    return cflags

def build(bld):
    cflags = dynconfig_cflags(bld)
    bld.SAMBA_SUBSYSTEM('DYNCONFIG',
                        'dynconfig.c',
                        deps='replace talloc',
                        public_headers='../version.h',
                        header_path='samba',
                        cflags=cflags)

=== source4/selftest/wscript ===
#!/usr/bin/env python
# vim: expandtab ft=python

# selftest main code.

import Scripting, os, Options, Utils, Environment, optparse, sys
from samba_utils import *
from samba_autoconf import *

def set_options(opt):

    opt.add_option('--enable-selftest',
                   help=("enable options necessary for selftest (default=no)"),
                   action="store_true", dest='enable_selftest', default=False)
    opt.add_option('--with-selftest-prefix',
                   help=("specify location of selftest directory (default=./st)"),
                   action="store", dest='SELFTEST_PREFIX', default='./st')

    opt.ADD_COMMAND('test', cmd_test)
    opt.ADD_COMMAND('testonly', cmd_testonly)

    gr = opt.add_option_group('test options')

    gr.add_option('--load-list', 
                  help=("Load a test id list from a text file"),
                  action="store", dest='LOAD_LIST', default=None)
    gr.add_option('--tests',
                  help=("wildcard pattern of tests to run"),
                  action="store", dest='TESTS', default='')
    gr.add_option('--filtered-subunit',
                  help=("output (xfail) filtered subunit"),
                  action="store_true", dest='FILTERED_SUBUNIT', default=False)
    gr.add_option('--quick',
                  help=("enable only quick tests"),
                  action="store_true", dest='QUICKTEST', default=False)
    gr.add_option('--slow',
                  help=("enable the really slow tests"),
                  action="store_true", dest='SLOWTEST', default=False)
    gr.add_option('--testenv',
                  help=("start a terminal with the test environment setup"),
                  action="store_true", dest='TESTENV', default=False)
    gr.add_option('--valgrind',
                  help=("use valgrind on client programs in the tests"),
                  action="store_true", dest='VALGRIND', default=False)
    gr.add_option('--valgrind-log',
                  help=("where to put the valgrind log"),
                  action="store", dest='VALGRINDLOG', default=None)
    gr.add_option('--valgrind-server',
                  help=("use valgrind on the server in the tests (opens an xterm)"),
                  action="store_true", dest='VALGRIND_SERVER', default=False)
    gr.add_option('--gdbtest',
                  help=("run the testsuite within a gdb xterm window"),
                  action="store_true", dest='GDBTEST', default=False)
    gr.add_option('--socket-wrapper-pcap',
                  help=("create a pcap file for each failing test"),
                  action="store_true", dest='SOCKET_WRAPPER_PCAP', default=False)
    gr.add_option('--socket-wrapper-keep-pcap',
                  help=("create a pcap file for all individual test"),
                  action="store_true", dest='SOCKET_WRAPPER_KEEP_PCAP', default=False)

def configure(conf):
    conf.env.SELFTEST_PREFIX = Options.options.SELFTEST_PREFIX

def cmd_testonly(opt):
    '''run tests without doing a build first'''
    env = LOAD_ENVIRONMENT()
    opt.env = env

    if (not CONFIG_SET(opt, 'NSS_WRAPPER') or
        not CONFIG_SET(opt, 'UID_WRAPPER') or
        not CONFIG_SET(opt, 'SOCKET_WRAPPER')):
        print("ERROR: You must use --enable-selftest to enable selftest")
        sys.exit(1)

    env.TESTS  = Options.options.TESTS

    env.SUBUNIT_FORMATTER = '${PYTHON} -u ../selftest/format-subunit --prefix=${SELFTEST_PREFIX} --immediate'
    env.FILTER_XFAIL = '${PYTHON} -u ../selftest/filter-subunit --expected-failures=./selftest/knownfail'
    env.FORMAT_TEST_OUTPUT = '${SUBUNIT_FORMATTER}'

    env.OPTIONS = ''
    if not Options.options.SLOWTEST:
        env.OPTIONS += ' --exclude=./selftest/slow'
    if Options.options.QUICKTEST:
        env.OPTIONS += ' --quick --include=./selftest/quick'
    if Options.options.LOAD_LIST:
        env.OPTIONS += ' --load-list=%s' % Options.options.LOAD_LIST
    if Options.options.TESTENV:
        env.OPTIONS += ' --testenv'
    if Options.options.SOCKET_WRAPPER_PCAP:
        env.OPTIONS += ' --socket-wrapper-pcap'
    if Options.options.SOCKET_WRAPPER_KEEP_PCAP:
        env.OPTIONS += ' --socket-wrapper-keep-pcap'

    if os.environ.get('RUN_FROM_BUILD_FARM') is not None:
        env.FILTER_OPTIONS = '${FILTER_XFAIL} --strip-passed-output'
    else:
        env.FILTER_OPTIONS = '${FILTER_XFAIL}'

    if Options.options.VALGRIND:
        os.environ['VALGRIND'] = 'valgrind -q --num-callers=30'
        if Options.options.VALGRINDLOG is not None:
            os.environ['VALGRIND'] += ' --log-file=%s' % Options.options.VALGRINDLOG

    if Options.options.VALGRIND_SERVER:
        os.environ['SAMBA_VALGRIND'] = 'xterm -n server -e ../selftest/valgrind_run DUMMY=X'

    if Options.options.GDBTEST:
        os.environ['SAMBA_VALGRIND'] = 'xterm -n server -e ../selftest/gdb_run DUMMY=X'

    # this is needed for systems without rpath, or with rpath disabled
    ADD_LD_LIBRARY_PATH('bin/shared')

    # tell build system where to find config.h
    os.environ['CONFIG_H'] = 'bin/default/source4/include/config.h'

    st_done = os.path.join(env.SELFTEST_PREFIX, 'st_done')
    if os.path.exists(st_done):
        os.unlink(st_done)

    cmd = '(${PERL} ../selftest/selftest.pl --prefix=${SELFTEST_PREFIX} --builddir=. --srcdir=. --exclude=./selftest/skip --testlist="./selftest/tests.sh|" ${OPTIONS} --socket-wrapper ${TESTS} && touch ${SELFTEST_PREFIX}/st_done) | ${FILTER_OPTIONS} | tee ${SELFTEST_PREFIX}/subunit'
    if os.environ.get('RUN_FROM_BUILD_FARM') is None and not Options.options.FILTERED_SUBUNIT:
        cmd += ' | ${FORMAT_TEST_OUTPUT}'
    cmd = EXPAND_VARIABLES(opt, cmd)

    print("test: running %s" % cmd)
    ret = RUN_COMMAND(cmd, env=env)
    if os.path.exists(".testrepository"):
        # "testr load -q" isn't
        cmd = 'testr load -q < ${SELFTEST_PREFIX}/subunit > /dev/null'
        cmd = EXPAND_VARIABLES(opt, cmd)
        RUN_COMMAND(cmd, env=env)

    if ret != 0:
        print("ERROR: test failed with exit code %d" % ret)
        sys.exit(ret)

    if not os.path.exists(st_done):
        print("ERROR: test command failed to complete")
        sys.exit(1)


########################################################################
# main test entry point
def cmd_test(opt):
    '''Run the test suite (see test options below)'''
    Scripting.commands.append('build')
    Scripting.commands.append('testonly')

=== source4/lib/ldb/wscript ===
#!/usr/bin/env python

APPNAME = 'ldb'
VERSION = '0.9.13'

blddir = 'bin'

import sys, os

# find the buildtools directory
srcdir = '.'
while not os.path.exists(srcdir+'/buildtools') and len(srcdir.split('/')) < 5:
    srcdir = '../' + srcdir
sys.path.insert(0, srcdir + '/buildtools/wafsamba')

import wafsamba, samba_dist

samba_dist.DIST_DIRS('''source4/lib/ldb:. lib/replace:lib/replace lib/talloc:lib/talloc
                        lib/tdb:lib/tdb lib/tevent:lib/tevent lib/popt:lib/popt
                        buildtools:buildtools''')


def set_options(opt):
    opt.BUILTIN_DEFAULT('replace')
    opt.BUNDLED_EXTENSION_DEFAULT('ldb', noextension='ldb')
    opt.RECURSE('lib/tdb')
    opt.RECURSE('lib/tevent')

def configure(conf):
    conf.RECURSE('lib/tdb')
    conf.RECURSE('lib/tevent')
    conf.RECURSE('lib/popt')

    # where does the default LIBDIR end up? in conf.env somewhere?
    #
    conf.CONFIG_PATH('LDB_MODULESDIR', conf.SUBST_ENV_VAR('MODULESDIR') + '/ldb')

    s4_build = getattr(conf.env, '_SAMBA_BUILD_', 0) == 4

    conf.env.standalone_ldb = conf.IN_LAUNCH_DIR()

    if not conf.env.standalone_ldb:
        if conf.CHECK_BUNDLED_SYSTEM('ldb', minversion=VERSION,
                                     onlyif='talloc tdb tevent',
                                     implied_deps='replace talloc tdb tevent'):
            conf.define('USING_SYSTEM_LDB', 1)

    if conf.env.standalone_ldb:
        conf.CHECK_XSLTPROC_MANPAGES()

        # we need this for the ldap backend
        if conf.CHECK_FUNCS_IN('ber_flush ldap_open ldap_initialize', 'lber ldap', headers='lber.h ldap.h'):
            conf.env.ENABLE_LDAP_BACKEND = True

    conf.DEFINE('HAVE_CONFIG_H', 1, add_to_cflags=True)

    conf.SAMBA_CONFIG_H()

def build(bld):
    bld.RECURSE('lib/tdb')
    bld.RECURSE('lib/tevent')
    bld.RECURSE('lib/popt')

    # in Samba4 we build some extra modules, and add extra
    # capabilities to the ldb cmdline tools
    s4_build = getattr(bld.env, '_SAMBA_BUILD_', 0) == 4

    LDB_MAP_SRC = bld.SUBDIR('ldb_map',
                             'ldb_map.c ldb_map_inbound.c ldb_map_outbound.c')

    COMMON_SRC = bld.SUBDIR('common',
                            '''ldb.c ldb_ldif.c ldb_parse.c ldb_msg.c ldb_utf8.c
                            ldb_debug.c ldb_dn.c ldb_match.c ldb_modules.c ldb_options.c
                            ldb_attributes.c attrib_handlers.c ldb_controls.c qsort.c''')

    if s4_build:
        builtin_ildap = not bld.CONFIG_SET('USING_SYSTEM_LDB')
        # this is only in the s4 build
        bld.SAMBA_MODULE('ldb_ildap', 'ldb_ildap/ldb_ildap.c',
                         init_function='LDB_BACKEND(ldapi),LDB_BACKEND(ldaps),LDB_BACKEND(ldap)',
                         deps='talloc LIBCLI_LDAP CREDENTIALS',
                         aliases='ldb_ldaps ldb_ldapi ldb_ldap',
                         internal_module=builtin_ildap,
                         subsystem='ldb')
    else:
        builtin_ildap = False
        # this is not included in the s4 build
        bld.SAMBA_MODULE('ldb_ldap', 'ldb_ldap/ldb_ldap.c',
                         init_function='LDB_BACKEND(ldapi),LDB_BACKEND(ldaps),LDB_BACKEND(ldap)',
                         deps='talloc lber ldap',
                         enabled=bld.env.ENABLE_LDAP_BACKEND,
                         subsystem='ldb')

    # we're not currently linking against the ldap libs, but ldb.pc.in
    # has @LDAP_LIBS@
    bld.env.LDAP_LIBS = ''

    if not 'PACKAGE_VERSION' in bld.env:
        bld.env.PACKAGE_VERSION = VERSION
        bld.env.PKGCONFIGDIR = '${LIBDIR}/pkgconfig'

    if builtin_ildap:
        abi_file = 'ABI/ldb-ildap-%s.sigs' % VERSION
    else:
        abi_file = 'ABI/ldb-%s.sigs' % VERSION

    bld.SAMBA_SUBSYSTEM('pyldb_util', deps='ldb',
            source='pyldb_util.c', needs_python=True)

    if not bld.CONFIG_SET('USING_SYSTEM_LDB'):
        modules_dir = bld.EXPAND_VARIABLES('${LDB_MODULESDIR}')
        if bld.env.standalone_ldb:
            bld.SAMBA_LIBRARY('ldb',
                              COMMON_SRC + ' ' + LDB_MAP_SRC,
                              deps='tevent',
                              includes='include',
                              public_headers='include/ldb.h include/ldb_errors.h '\
                                  'include/ldb_module.h include/ldb_handlers.h',
                              pc_files='ldb.pc',
                              cflags='-DLDB_MODULESDIR=\"%s\"' % modules_dir,
                              abi_file=abi_file,
                              abi_match='!ldb_*module_ops !ldb_*backend_ops ldb_*',
                              vnum=VERSION, manpages='man/ldb.3',
                              is_bundled=not bld.env.standalone_ldb)
        else:
            bld.SAMBA_LIBRARY('ldb',
                              COMMON_SRC + ' ' + LDB_MAP_SRC,
                              deps='tevent',
                              includes='include',
                              public_headers='include/ldb.h include/ldb_errors.h '\
                                  'include/ldb_module.h include/ldb_handlers.h',
                              pc_files='ldb.pc',
                              cflags='-DLDB_MODULESDIR=\"%s\"' % modules_dir,
                              vnum=VERSION, manpages='man/ldb.3',
                              is_bundled=not bld.env.standalone_ldb)

        bld.SAMBA_PYTHON('pyldb', 'pyldb.c',
                         deps='ldb pyldb_util',
                         realname='ldb.so')

        bld.SAMBA_MODULE('ldb_paged_results',
                         'modules/paged_results.c',
                         init_function='LDB_MODULE(paged_results)',
                         subsystem='ldb')

        bld.SAMBA_MODULE('ldb_asq',
                         'modules/asq.c',
                         init_function='LDB_MODULE(asq)',
                         subsystem='ldb')

        bld.SAMBA_MODULE('ldb_server_sort',
                         'modules/sort.c',
                         init_function='LDB_MODULE(server_sort)',
                         subsystem='ldb')

        bld.SAMBA_MODULE('ldb_paged_searches',
                         'modules/paged_searches.c',
                         init_function='LDB_MODULE(paged_searches)',
                         enabled = s4_build,
                         subsystem='ldb')

        bld.SAMBA_MODULE('ldb_rdn_name',
                         'modules/rdn_name.c',
                         init_function='LDB_MODULE(rdn_name)',
                         subsystem='ldb')

        bld.SAMBA_MODULE('ldb_sample',
                         'tests/sample_module.c',
                         init_function='LDB_MODULE(sample)',
                         subsystem='ldb')

        bld.SAMBA_MODULE('ldb_skel',
                         'modules/skel.c',
                         init_function='LDB_MODULE(skel)',
                         subsystem='ldb')

        bld.SAMBA_MODULE('ldb_sqlite3',
                         'sqlite3/ldb_sqlite3.c',
                         init_function='LDB_BACKEND(sqlite3)',
                         enabled=False,
                         subsystem='ldb')

        bld.SAMBA_MODULE('ldb_tdb',
                         bld.SUBDIR('ldb_tdb',
                                    '''ldb_tdb.c ldb_pack.c ldb_search.c ldb_index.c
                                    ldb_cache.c ldb_tdb_wrap.c'''),
                         init_function='LDB_BACKEND(tdb)',
                         deps='tdb',
                         subsystem='ldb')

    if s4_build:
        extra_cmdline_deps = ' LDBSAMBA POPT_SAMBA POPT_CREDENTIALS ' \
                'LIBCMDLINE_CREDENTIALS gensec'
    else:
        extra_cmdline_deps = ''

    bld.SAMBA_SUBSYSTEM('LIBLDB_CMDLINE',
                        'tools/ldbutil.c tools/cmdline.c',
                        'ldb dl popt' + extra_cmdline_deps)

    LDB_TOOLS='ldbadd ldbsearch ldbdel ldbmodify ldbedit ldbrename'
    for t in LDB_TOOLS.split():
        bld.SAMBA_BINARY(t, 'tools/%s.c' % t, deps='LIBLDB_CMDLINE',
                         manpages='man/%s.1' % t)

    # ldbtest doesn't get installed
    bld.SAMBA_BINARY('ldbtest', 'tools/ldbtest.c', deps='LIBLDB_CMDLINE',
                     install=False)


def test(ctx):
    '''run ldb testsuite'''
    import Utils
    cmd = 'tests/test-tdb.sh'
    os.system(cmd)

def dist():
    '''makes a tarball for distribution'''
    samba_dist.dist()

=== source4/lib/tls/wscript ===
#!/usr/bin/env python

import Options
from optparse import SUPPRESS_HELP

def set_options(opt):
    # allow users to disable gnutls
    opt.add_option('--enable-gnutls',
                   help=("Enable use of gnutls"),
                   action="store_true", dest='enable_gnutls', default=True)
    opt.add_option('--disable-gnutls', help=SUPPRESS_HELP, action="store_false", dest='enable_gnutls')


def configure(conf):
    conf.env.enable_gnutls = Options.options.enable_gnutls
    if not conf.env.enable_gnutls:
        conf.SET_TARGET_TYPE('gnutls', 'DISABLED')
        conf.SET_TARGET_TYPE('gcrypt', 'DISABLED')
        conf.SET_TARGET_TYPE('gpg-error', 'DISABLED')
        return

    conf.check_cfg(package='gnutls',
                   args='"gnutls >= 1.4.0" --cflags --libs',
                   msg='Checking for gnutls >= 1.4.0', mandatory=False)

    if 'HAVE_GNUTLS' in conf.env:
        conf.DEFINE('ENABLE_GNUTLS', 1)

    conf.CHECK_FUNCS_IN('gnutls_global_init', 'gnutls',
                        headers='gnutls/gnutls.h')

    conf.CHECK_VARIABLE('gnutls_x509_crt_set_version',
                        headers='gnutls/gnutls.h gnutls/x509.h',
                        define='HAVE_GNUTLS_X509_CRT_SET_VERSION',
                        lib='gnutls')
    conf.CHECK_VARIABLE('gnutls_x509_crt_set_subject_key_id',
                        headers='gnutls/gnutls.h gnutls/x509.h',
                        define='HAVE_GNUTLS_X509_CRT_SET_SUBJECT_KEY_ID',
                        lib='gnutls')

    # check for gnutls_datum types
    conf.CHECK_TYPES('gnutls_datum gnutls_datum_t',
                     headers='gnutls/gnutls.h', lib='gnutls')

    conf.CHECK_FUNCS_IN('gcry_control', 'gcrypt', headers='gcrypt.h')
    conf.CHECK_FUNCS_IN('gpg_err_code_from_errno', 'gpg-error')


def build(bld):
    bld.SAMBA_SUBSYSTEM('LIBTLS',
                        source='tls.c tlscert.c',
                        public_deps='talloc gnutls gcrypt LIBSAMBA-HOSTCONFIG samba_socket'
                        )

=== debian/changelog ===
samba4 (4.0.0~alpha13+git+bzr12984.dfsg1-0ubuntu1) maverick; urgency=low

  * New upstream snapshot. (LP: #636400)
  * Support talloc 2.0.1.
  * Update dependency for ldb to be >= 0.9.13.
  * Remove dependencies on subunit, testtools as the testsuite is not
    being run yet at build time.

 -- Jelmer Vernooij <jelmer@debian.org>  Sun, 12 Sep 2010 14:52:04 +0200

samba4 (4.0.0~alpha13+git+bzr12785.dfsg1-1) experimental; urgency=low

  * Install provision scripts to /usr/share/samba/setup.
  * Move nsstest from samba4 to winbind4.
  * Support building against tdb 1.2.1.

 -- Jelmer Vernooij <jelmer@debian.org>  Fri, 10 Sep 2010 17:45:20 +0200

samba4 (4.0.0~alpha13+git+bzr12687.dfsg1-1) experimental; urgency=low

  * New upstream snapshot.
  * Mark as compatible with older versions of tdb (>= 1.2.2).

 -- Jelmer Vernooij <jelmer@debian.org>  Wed, 08 Sep 2010 03:30:03 +0200

samba4 (4.0.0~alpha13+git+bzr12670.dfsg1-1) experimental; urgency=low

  * Add missing dependency on pkg-config.
  * Require subunit >= 0.0.6, older versions have a broken tap2subunit.
  * Debconf translations:
    - Swedish (Martin Bagge).  Closes: #586819
  * New upstream snapshot.
    - Fixes symbols for LDB modules. Closes: #594763, #594771, #594773.
  * Require tdb 1.2.3. Closes: #595644

 -- Jelmer Vernooij <jelmer@debian.org>  Sun, 05 Sep 2010 17:34:46 +0200

samba4 (4.0.0~alpha13+git+bzr12292.dfsg1-1) experimental; urgency=low

  * New upstream snapshot.
   + Fixes provision to be able to find the data path again.
  * Depend on libreadline-dev rather than libreadline5-dev. Closes: #553846
  * Suggest swat2.
  * Migrate to Bazaar.
  * Bump standards version to 3.9.1 (no changes).

 -- Jelmer Vernooij <jelmer@debian.org>  Sun, 22 Aug 2010 02:38:51 +0200

samba4 (4.0.0~alpha13+git20100618.dfsg1-1) experimental; urgency=low

  [ Jelmer Vernooij ]
  * New upstream snapshot. Closes: #578009, #577880
   + Add dependency on python-dnspython.
   + Removes last Python string exception. Closes: #585327
   + Installs all display specifiers. Closes: #548911

  [ Christian Perrier ]
  * Debconf translations:
    - Swedish (Martin Bagge).  Closes: #552734
    - Russian (Yuri Kozlov).  Closes: #563346
    - Spanish (Omar Campagne).  Closes: #579099

 -- Jelmer Vernooij <jelmer@debian.org>  Sun, 28 Feb 2010 02:33:37 +0100

samba4 (4.0.0~alpha8+git20100227.dfsg1-1) experimental; urgency=low

  * Fix sections of libndr-standard0 and libndr0.
  * New upstream snapshot.

 -- Jelmer Vernooij <jelmer@debian.org>  Mon, 22 Feb 2010 11:19:07 +0100

samba4 (4.0.0~alpha8+git20100222.dfsg1-1) experimental; urgency=low

  [ Christian Perrier ]
  * Change "Provides:" in init script to avoid conflicting Provides
    with samba. Closes: #547209
  * Swedish debconf translation (Martin Bagge).  Closes: #552734

  [ Jelmer Vernooij ]
  * Depend on specific version of libldb. Closes: #562389
  * Build against system Heimdal and remove the copy of Heimdal from the 
    Samba 4 source tree, since it contains non-free IETF RFC/I-D.
    Closes: #547280
  * Bump standards version to 3.8.4.
  * Switch to dpkg-source 3.0 (quilt) format

 -- Jelmer Vernooij <jelmer@debian.org>  Wed, 03 Feb 2010 15:17:20 +0100

samba4 (4.0.0~alpha8+git20090912-1) unstable; urgency=low

  * Upload to unstable.
  * Fix nmblookup.1.gz filename for alternatives.
  * New upstream snapshot.
   + Add new binary packages libndr-standard0 and libndr-standard-dev.
  * Bump standards version to 3.8.3.
  * Remove unused patch system.

 -- Jelmer Vernooij <jelmer@debian.org>  Sat, 12 Sep 2009 13:28:33 +0200

samba4 (4.0.0~alpha8+git20090718-1) experimental; urgency=low

  * New upstream snapshot.
  * The server package now suggests a version of bind9 that supports 
    update-policy.

 -- Jelmer Vernooij <jelmer@debian.org>  Sat, 18 Jul 2009 17:34:30 +0200

samba4 (4.0.0~alpha8~git20090620-1) experimental; urgency=low

  * Support building against Python2.6.
  * Add missing dependency on tdb >= 1.1.3. (Closes: #517171)
  * Add missing dependencies on tdb-dev and libtalloc-dev to
    libldb-samba4-dev. (Closes: #525885)
  * Use newer version of tevent. (Closes: #531480, #533457, #533455)
  * New upstream snapshot.
  * Bump standards version to 3.8.2.
  * Reorganization to let Samba 3 and Samba 4 co-exist on the same system:
   + Depend on samba-common for smb.conf, /etc/samba/gdbcommands,
     /usr/share/samba/{panic-action,*.dat}.
   + Rename samba4-common to samba4-common-bin.
  * samba4-testsuite now recommends subunit, since it can output subunit
    streams.
  * Document license for Active Directory schemas.
  * Fix init script to run samba rather than smbd. (Closes: #522646)
  * Removed libldb-samba4-{dev,0}, now using libldb{-dev,0} since there
    are no longer any differences.

 -- Jelmer Vernooij <jelmer@debian.org>  Thu, 18 Jun 2009 00:19:44 +0200

samba4 (4.0.0~alpha7~20090225-1) experimental; urgency=low

  * Build-depend on pkg-config, as we no longer seem to pull that in 
    through any other dependencies. (Closes: #516882)

 -- Jelmer Vernooij <jelmer@debian.org>  Wed, 25 Feb 2009 04:04:36 +0100

samba4 (4.0.0~alpha7~20090223-1) experimental; urgency=low

  * Add build dependency on libpopt-dev, so the system libpopt is always used 
    rather than the one included by Samba.
  * Use the alternatives system for the smbstatus, nmblookup, net and testparm 
    binaries as well as various data files.
  * Make the samba4 and samba4-testsuite packages conflict with 
    samba-tools. (Closes: #506236)
  * Build against external libtevent.

 -- Jelmer Vernooij <jelmer@debian.org>  Sat, 21 Feb 2009 17:46:41 +0100

samba4 (4.0.0~alpha6-1) experimental; urgency=low

  * New upstream release.

 -- Jelmer Vernooij <jelmer@debian.org>  Tue, 20 Jan 2009 02:59:15 +0100

samba4 (4.0.0~alpha5+20090105-1) experimental; urgency=low

  * New upstream snapshot.

 -- Jelmer Vernooij <jelmer@debian.org>  Mon, 05 Jan 2009 21:08:53 +0100



=== debian/control ===
Source: samba4
Section: net
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Samba Debian Maintainers <pkg-samba-maint@lists.alioth.debian.org>
Uploaders: Steve Langasek <vorlon@debian.org>, Christian Perrier <bubulle@debian.org>, Noèl Köthe <noel@debian.org>, Steinar H. Gunderson <sesse@debian.org>, Jelmer Vernooij <jelmer@debian.org>
Homepage: http://www.samba.org/
Standards-Version: 3.9.1
Build-Depends: debhelper (>> 5.0.0), libparse-yapp-perl, perl, docbook-xsl, docbook-xml, xsltproc, po-debconf, libgnutls-dev, libreadline5-dev, libpam0g-dev, libblkid-dev, libattr1-dev, flex, bison, libtdb-dev (>= 1.2.1~), libtalloc-dev (>= 2.0.1~), libtevent-dev (>= 0.9.9~), perl-modules, python-dev, python-central (>= 0.5.6), libpopt-dev, pkg-config, samba-common (>= 2:3.4.0~pre2), libldb-dev (>= 1:0.9.13~), python-ldb, python-tdb, zlib1g-dev (>= 1:1.2.3), heimdal-multidev (>= 1.4~), python-dnspython
Vcs-Browser: http://bzr.debian.org/lh/pkg-samba/samba4/unstable
Vcs-Bzr: http://bzr.debian.org/pkg-samba/samba4/unstable
XS-Python-Version: current
DM-Upload-Allowed: yes

Package: samba4
Architecture: any
Recommends: samba-ldb-tools
Suggests: bind9 (>= 1:9.5.1), phpldapadmin, swat2
Conflicts: samba-tools, samba (<< 2:3.3.0~rc2-5)
Depends: ${shlibs:Depends}, ${misc:Depends}, samba4-common-bin (=${source:Version}), python, python-samba, ${python:Depends}, python-dnspython
XB-Python-Version: ${python:Versions}
Description: SMB/CIFS file, print and logon server (version 4)
 The Samba software suite is a collection of programs that
 implements the SMB protocol for unix systems, allowing you to serve
 files to Windows, NT, OS/2 and DOS clients, as well as
 run as a domain controller for Active Directory.
 .
 These packages contain snapshot versions of Samba 4, the next-generation
 version of Samba. These should be considered _experimental_, and should
 not be used in production.
 .
 This package contains smbd, the Samba file, print and domain server.

Package: samba4-common-bin
Architecture: all
Depends: ${misc:Depends}, samba-common (>= 2:3.4.0~pre2-1), ${python:Depends}
Conflicts: samba (<< 2:3.3.0~rc2-5), samba-common (<< 2:3.3.0~rc2-5)
Replaces: samba4-common (<< 2:3.4.0~pre2-1), samba4-common (<< 4.0.0~alpha7-1)
XB-Python-Version: ${python:Versions}
Description: Samba 4 common files used by both the server and the client
 The Samba software suite is a collection of programs that
 implements the SMB/CIFS protocol for unix systems, allowing you to serve
 files to Windows, NT, OS/2 and DOS clients. This protocol
 is sometimes also referred to as the LanManager or NetBIOS protocol.
 .
 These packages contain snapshot versions of Samba 4, the next-generation
 version of Samba. These should be considered _experimental_, and should
 not be used in production.
 .
 This package contains the common files that are used by both the server
 (provided in the samba package) and the client (provided in the samba-clients
 package).

Package: samba4-clients
Architecture: any
Depends: ${shlibs:Depends}, samba4-common-bin (=${source:Version}), ${misc:Depends}
Conflicts: smbclient, samba-common (<< 2:3.3.0~rc2-5)
XB-Python-Version: ${python:Versions}
Provides: smbclient
Description: client utilities from Samba 4
 The Samba software suite is a collection of programs that
 implements the SMB protocol for unix systems, allowing you to serve
 files to Windows, NT, OS/2 and DOS clients. This protocol
 is sometimes also referred to as the LanManager or NetBIOS protocol.
 .
 These packages contain snapshot versions of Samba 4, the next-generation
 version of Samba.
 .
 This package contains some client components of the Samba suite. In
 particular it includes the command line utilities smbclient, net,
 and some ACL tools.

Package: samba4-testsuite
Architecture: any
Conflicts: samba-tools
Recommends: subunit
Depends: ${shlibs:Depends}, samba4-common-bin, ${misc:Depends}
XB-Python-Version: ${python:Versions}
Description: test suite from Samba 4
 The Samba software suite is a collection of programs that
 implements the SMB protocol for unix systems, allowing you to serve
 files to Windows, NT, OS/2 and DOS clients, as well as
 run as a domain controller for Active Directory.
 .
 This package contains programs for testing the reliability and speed
 of SMB servers, Samba in particular.

Package: registry-tools
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
XB-Python-Version: ${python:Versions}
Description: tools for viewing and manipulating the Windows registry
 The Samba software suite is a collection of programs that
 implements the SMB protocol for unix systems, allowing you to serve
 files to Windows, NT, OS/2 and DOS clients, as well as
 run as a domain controller for Active Directory.
 .
 These packages contain snapshot versions of Samba 4, the next-generation
 version of Samba. These should be considered _experimental_, and should
 not be used in production.
 .
 This package contains tools for viewing and manipulating the binary
 "registry" found on Windows machines, both locally and remote.

Package: libparse-pidl-perl
Architecture: any
Depends: ${perl:Depends}, libparse-yapp-perl, ${misc:Depends}
Recommends: libdcerpc-dev
Section: perl
XB-Python-Version: ${python:Versions}
Description: IDL compiler written in Perl
 The Samba software suite is a collection of programs that
 implements the SMB protocol for unix systems, allowing you to serve
 files to Windows, NT, OS/2 and DOS clients, as well as
 run as a domain controller for Active Directory.
 .
 This package contains the IDL (Interface Description Language) compiler pidl,
 which takes in IDL files and can output C code for various uses. It is
 primarily of interest to developers.

Package: samba4-dev
Architecture: any
Depends: libparse-pidl-perl, libc6-dev, libldb-dev, libtdb-dev (>= 1.1.0), libtalloc-dev, ${misc:Depends}
Section: devel
XB-Python-Version: ${python:Versions}
Description: tools for extending Samba
 The Samba software suite is a collection of programs that
 implements the SMB protocol for unix systems, allowing you to serve
 files to Windows, NT, OS/2 and DOS clients, as well as
 run as a domain controller for Active Directory.
 .
 These packages contain snapshot versions of Samba 4, the next-generation
 version of Samba. These should be considered _experimental_, and should
 not be used in production.
 .
 This package contains include files shared by the various Samba-based
 libraries.

Package: samba-ldb-tools
Section: utils
Architecture: any
Provides: ldb-tools
Conflicts: ldb-tools
Depends: ${shlibs:Depends}, ${misc:Depends}
XB-Python-Version: ${python:Versions}
Description: LDAP-like embedded database - tools
 ldb is a LDAP-like embedded database built on top of TDB.
 .
 What ldb does is provide a fast database with an LDAP-like API designed
 to be used within an application. In some ways it can be seen as a
 intermediate solution between key-value pair databases and a real LDAP
 database.
 .
 This package contains bundled test and utility binaries built specifically
 for Samba.

Package: libgensec0
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, samba-common (>= 2:3.4.0~pre2-1)
XB-Python-Version: ${python:Versions}
Description: Generic Security Library
 The Samba software suite is a collection of programs that
 implements the SMB protocol for unix systems, allowing you to serve
 files to Windows, NT, OS/2 and DOS clients, as well as
 run as a domain controller for Active Directory.
 .
 These packages contain snapshot versions of Samba 4, the next-generation
 version of Samba.
 .
 This library provides a generalized API for several security protocols.

Package: libgensec-dev
Architecture: any
Section: libdevel
Depends: libgensec0 (=${binary:Version}), pkg-config, ${misc:Depends}
XB-Python-Version: ${python:Versions}
Description: Generic Security Library
 The Samba software suite is a collection of programs that
 implements the SMB protocol for unix systems, allowing you to serve
 files to Windows, NT, OS/2 and DOS clients, as well as
 run as a domain controller for Active Directory.
 .
 These packages contain snapshot versions of Samba 4, the next-generation
 version of Samba.
 .
 This library provides a generalized API for several security protocols.
 .
 This package contains the files required for development.

Package: libndr0
Architecture: any
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}
XB-Python-Version: ${python:Versions}
Description: NDR marshalling library
 The Samba software suite is a collection of programs that
 implements the SMB protocol for unix systems, allowing you to serve
 files to Windows, NT, OS/2 and DOS clients, as well as
 run as a domain controller for Active Directory.
 .
 This package contains the library for encoding and decoding data structures
 using the Network Data Representation format as used by DCE/RPC.

Package: libndr-dev
Architecture: any
Section: libdevel
Depends: libndr0 (=${binary:Version}), pkg-config, ${misc:Depends}
XB-Python-Version: ${python:Versions}
Description: NDR marshalling library - development files
 The Samba software suite is a collection of programs that
 implements the SMB protocol for unix systems, allowing you to serve
 files to Windows, NT, OS/2 and DOS clients, as well as
 run as a domain controller for Active Directory.
 .
 This package contains the library for encoding and decoding data structures
 using the Network Data Representation format as used by DCE/RPC.
 .
 This package contains the files required for development.

Package: libndr-standard0
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
XB-Python-Version: ${python:Versions}
Description: Standard NDR interfaces
 The Samba software suite is a collection of programs that
 implements the SMB protocol for unix systems, allowing you to serve
 files to Windows, NT, OS/2 and DOS clients, as well as
 run as a domain controller for Active Directory.
 .
 This package contains NDR encoders/decoders for the set of standard
 DCE/RPC interfaces found on Windows and Samba servers.

Package: libndr-standard-dev
Architecture: any
Section: libdevel
Depends: libndr-standard0 (=${binary:Version}), pkg-config, ${misc:Depends}
XB-Python-Version: ${python:Versions}
Description: Standard NDR interfaces - development files
 The Samba software suite is a collection of programs that
 implements the SMB protocol for unix systems, allowing you to serve
 files to Windows, NT, OS/2 and DOS clients, as well as
 run as a domain controller for Active Directory.
 .
 This package contains NDR encoders/decoders for the set of standard
 DCE/RPC interfaces found on Windows and Samba servers.
 .
 This package contains the files required for development.

Package: libdcerpc0
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
XB-Python-Version: ${python:Versions}
Description: DCE/RPC client library
 The Samba software suite is a collection of programs that
 implements the SMB protocol for unix systems, allowing you to serve
 files to Windows, NT, OS/2 and DOS clients, as well as
 run as a domain controller for Active Directory.
 .
 These packages contain snapshot versions of Samba 4, the next-generation
 version of Samba.
 .
 Client-side implementation of the DCE/RPC protocol.
 Support for the following transports is provided:
  - ncacn_np
  - ncacn_ip_tcp
  - ncalrpc
  - ncacn_sock_unix

Package: libdcerpc-dev
Architecture: any
Section: libdevel
Depends: libdcerpc0 (=${binary:Version}), libndr-dev, pkg-config, ${misc:Depends}, libsamba-util-dev
XB-Python-Version: ${python:Versions}
Description: DCE/RPC library
 The Samba software suite is a collection of programs that
 implements the SMB protocol for unix systems, allowing you to serve
 files to Windows, NT, OS/2 and DOS clients, as well as
 run as a domain controller for Active Directory.
 .

=== debian/rules ===
#!/usr/bin/make -f
# By Jelmer Vernooij <jelmer@samba.org>

SOURCEPATH=./source4
DESTDIR = $(CURDIR)/debian/tmp

CFLAGS = -Wall -O0
LDFLAGS = -Wl,--as-needed

PYVERS=$(shell pyversions -vr)

WAF = ../buildtools/bin/waf

# turn DEB_BUILD_OPTIONS='foo,bar' into DEB_BUILD_OPT_FOO and DEB_BUILD_OPT_BAR
d_b_o:=$(shell echo "$$DEB_BUILD_OPTIONS"|sed 's/[^-[:alnum:]]/ /g'|tr a-z A-Z)
$(foreach o, $(d_b_o), $(eval DEB_BUILD_OPT_$o := 1))

configure: configure-stamp
configure-stamp:
	dh_testdir
	cd $(SOURCEPATH) && CFLAGS="$(CFLAGS)" LDFLAGS="$(LDFLAGS)" $(WAF) configure --enable-fhs \
		--prefix=/usr \
		--mandir=/usr/share/man \
		--sysconfdir=/etc \
		--localstatedir=/var \
		--with-piddir=/var/run \
		--disable-rpath \
		--disable-rpath-install \
		--bundled-libraries=NONE \
		--builtin-libraries=replace \
		--minimum-library-version=tdb:1.2.1,talloc:2.0.1
	touch $@

build: build-stamp
build-stamp: configure
	dh_testdir
	cd $(SOURCEPATH) && $(WAF) build
	touch $@

clean:
	dh_testdir
	dh_testroot
	dh_clean
	$(RM) $(DESTDIR)
	-cd $(SOURCEPATH) && $(WAF) clean
	find . -name "*.pyc" | xargs rm -f
	rm -rf buildtools/bin/.waf-*
	$(RM) build-stamp configure-stamp

binary-indep: build install
	dh_installdocs -i
	dh_installchangelogs -i
	dh_pycentral -i
	dh_compress -i
	dh_fixperms -i
	dh_installdebconf -i
	dh_installdeb -i
	dh_gencontrol -i
	dh_md5sums -i
	dh_builddeb -i

install: build
	dh_installdirs
	mkdir -p $(DESTDIR)/usr/share/man/man1
	mkdir -p $(DESTDIR)/etc/samba
	cd $(SOURCEPATH) && DESTDIR="$(DESTDIR)" $(WAF) install
	dh_testdir
	dh_testroot
	# Alternatives are used
	mv $(DESTDIR)/usr/bin/nmblookup $(DESTDIR)/usr/bin/nmblookup.samba4
	mv $(DESTDIR)/usr/share/man/man1/nmblookup.1 $(DESTDIR)/usr/share/man/man1/nmblookup.samba4.1
	mv $(DESTDIR)/usr/bin/net $(DESTDIR)/usr/bin/net.samba4
	mv $(DESTDIR)/usr/bin/testparm $(DESTDIR)/usr/bin/testparm.samba4
	# Already provided by samba-common
	rm $(DESTDIR)/usr/share/samba/*.dat
	# Already provided by libparse-yapp-perl
	rm $(DESTDIR)/usr/share/perl5/Parse/Yapp/Driver.pm
	# Binaries not ready for installation
	rm $(DESTDIR)/usr/lib/mit_samba.so
	# Included in python-tdb
	rm $(DESTDIR)/usr/lib/python*/*-packages/tdb.so
	# Already included in various system packages
	rm -r $(DESTDIR)/usr/lib/python*/*-packages/samba/external
	# Already documented in debian/copyright
	rm $(DESTDIR)/usr/share/samba/setup/ad-schema/licence.txt
	# System ldb loads its modules from a different path
	mv $(DESTDIR)/usr/lib/samba/ldb $(DESTDIR)/usr/lib/ldb
	ln -sf ../ldb $(DESTDIR)/usr/lib/samba/ldb
	mkdir -p $(DESTDIR)/lib/security
	mv $(DESTDIR)/usr/lib/pam_winbind.so $(DESTDIR)/lib/security/pam_winbind.so
	mv $(DESTDIR)/usr/sbin/provision $(DESTDIR)/usr/sbin/upgradeprovision $(DESTDIR)/usr/share/samba/setup
	mv $(DESTDIR)/usr/lib/libnss_winbind.so.2 $(DESTDIR)/lib
	dh_install --sourcedir=$(DESTDIR) --list-missing --fail-missing

get-orig-source:
	./debian/build-orig.sh

binary-arch: build install
	dh_installdocs -a debian/README.building $(SOURCEPATH)/NEWS
	dh_installchangelogs -a
	dh_strip -a
	dh_perl -a
	dh_pycentral -a
	dh_compress -a
	dh_fixperms -a
	dh_makeshlibs -a
	dh_link -plibsamba-hostconfig0 usr/lib/libsamba-hostconfig.so.0.0.1 usr/lib/libsamba-hostconfig.so.0
	dh_link -plibndr0 usr/lib/libndr.so.0.0.1 usr/lib/libndr.so.0
	dh_link -plibndr-standard0 usr/lib/libndr_standard.so.0.0.1 usr/lib/libndr_standard.so.0
	dh_link -plibregistry0 usr/lib/libregistry.so.0.0.1 usr/lib/libregistry.so.0
	dh_link -plibdcerpc0 usr/lib/libdcerpc.so.0.0.1 usr/lib/libdcerpc.so.0 \
						 usr/lib/libdcerpc_samr.so.0.0.1 usr/lib/libdcerpc_samr.so.0 \
						 usr/lib/libdcerpc_atsvc.so.0.0.1 usr/lib/libdcerpc_atsvc.so.0
	dh_link -plibgensec0 usr/lib/libgensec.so.0.0.1 usr/lib/libgensec.so.0
	dh_link -plibtorture0 usr/lib/libtorture.so.0.0.1 usr/lib/libtorture.so.0
	dh_link -plibsamba-util0 usr/lib/libsamba-util.so.0.0.1 usr/lib/libsamba-util.so.0
	for pkg in winbind4; do \
		install -m 0644 -D debian/$$pkg.lintian debian/$$pkg/usr/share/lintian/overrides/$$pkg || exit; \
	done
	dh_installinit -a 
	dh_installdebconf -a
	dh_installdeb -a
	dh_shlibdeps -a
	dh_gencontrol -a
	dh_md5sums -a
	dh_builddeb -a

binary: binary-arch binary-indep 

.PHONY: configure build install binary binary-arch binary-indep clean
